//+------------------------------------------------------------------+
//|                                     MovingAverage - Firstock.mq4 |
//|                                        Copyright 2021, Algomojo. |
//|                                         https://www.algomojo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Algomojo."
#property link      "https://www.algomojo.com"
#property version   "1.00"
#property strict
#property script_show_inputs
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+



//Algomojo Autotrading Modules


input string uid = "xxxxx"; //Entry your Account Id
input string user_apikey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API key here
input string api_secretkey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API secret key here

input string tsym = "NIFTY29JUL21F"; //Trading Symbol Name


enum exchange{
   NSE,
   BSE,
   NFO,
   MCX
};

enum producttype{
  MKT,
  LMT,
 
 

};

enum product{
   C,
   M,
   I
};




enum br{
   fs
};


  

input exchange exch = NFO; //Exchange
input producttype prctyp =MKT; // Order Type
input product prd =I; // Product Code
input int prc = 0; 
input int trgprc = 0;
input int qty = 50;
input string ret = "DAY";
input string remarks = "Algomojo";
input string ordersource ="WEB";



input string strg_name = "Metatrader Strategy"; // Strategy Name
input br broker = fs; //Broker Short code ab - aliceblue, tj- tradejini, zb - zebu , en - enrich
input string ver = "1.0"; //API Version




string response;
string api_data;
int Buy;
int Sell;

static int BarsOnChart;

#import "AMMT4BRIDGE.dll"
     string AMDispatcher(string api_key, string api_secret, string api_name, string api_data, string br_code, string version);
#import

//+------------------------------------------------------------------+
//| BuyOrder  function                                               |
//+------------------------------------------------------------------+  


void BuyOrder(int orderqty)
   {
  
     //Algomojo Place Buy Order


      api_data ="{\"strg_name\":\""+strg_name+"\",\"uid\":\""+uid+"\",\"actid\":\""+uid+"\",\"exch\":\""+EnumToString(exch)+"\",\"tsym\":\""+tsym+"\",\"qty\":\""+IntegerToString(orderqty)+"\",\"prc\":\""+IntegerToString(prc)+"\",\"trgprc\":\""+IntegerToString(trgprc)+"\",\"prd\":\""+EnumToString(prd)+"\",\"trantype\":\""+"B"+"\",\"prctyp\":\""+EnumToString(prctyp)+"\",\"ret\":\""+ret+"\",\"remarks\":\""+remarks+"\",\"ordersource\":\""+ordersource+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Buy Order response : " ,response);
      
      
    }


//+------------------------------------------------------------------+
//| SellOrder  function                                              |
//+------------------------------------------------------------------+    
    
void SellOrder(int orderqty)
   {
  
      //Algomojo Place Sell Order
      api_data ="{\"strg_name\":\""+strg_name+"\",\"uid\":\""+uid+"\",\"actid\":\""+uid+"\",\"exch\":\""+EnumToString(exch)+"\",\"tsym\":\""+tsym+"\",\"qty\":\""+IntegerToString(orderqty)+"\",\"prc\":\""+IntegerToString(prc)+"\",\"trgprc\":\""+IntegerToString(trgprc)+"\",\"prd\":\""+EnumToString(prd)+"\",\"trantype\":\""+"S"+"\",\"prctyp\":\""+EnumToString(prctyp)+"\",\"ret\":\""+ret+"\",\"remarks\":\""+remarks+"\",\"ordersource\":\""+ordersource+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Sell Order response : " ,response);
         
   
   
   }         

int OnInit()
  {
//---
  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---   
   Buy = Close[1] > EMA(10,1)  && Close[2] < EMA(10,2);
   Sell = Close[1] < EMA(10,1) && Close[2] > EMA(10,2);
   
   if(Buy && BarsOnChart != Bars) {      
       BuyOrder(qty);
       Print("Buy Signal");
       BarsOnChart = Bars;
       PlaySound("Ok.wav");
   }
  
   
   if(Sell && BarsOnChart != Bars) {
      SellOrder(qty);
      Print("Sell Signal");
      BarsOnChart = Bars;
      PlaySound("Ok.wav");
   }   
  
  }
//+------------------------------------------------------------------+

double EMA(int period,int shift) {
   return iMA(Symbol(), 0, period, 0, MODE_EMA, PRICE_CLOSE, shift);
  
}




