//+------------------------------------------------------------------+
//|                                       MovingAverage - Upstox.mq4 |
//|                                        Copyright 2021, Algomojo. |
//|                                         https://www.algomojo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Algomojo."
#property link      "https://www.algomojo.com"
#property version   "1.00"
#property strict
#property script_show_inputs
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+



//Algomojo Autotrading Modules

input string user_apikey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API key here
input string api_secretkey = "xxxxxxxxxxxxxxxxxxxxxx"; //Enter your API secret key here

input string symbol = "NIFTY21JULFUT"; //Symbol Name


enum exch{
   NSE_FO,
   NSE_EQ,
   BSE_EQ,
   NCD_FO,
   MCX_FO,
   BCD_FO
};

enum otype{
   MKT,
   L,
   SL,
    
};

enum ptype{
   NRML,
   BO,
   CNC,
   CO,
   MIS
};



enum br{
   up
};


  

input exch exchange = NSE_FO; //Exchange
input otype order_type =MKT; // Order Type
input ptype product =MIS; // Product Code
input int Price = 0;
input int TrigPrice = 0;
input int quantity = 50;

input int disclosed_quantity = 0;
input string duration = "DAY";
input string AMO = "NO";



input string stgy_name = "Metatrader Strategy"; // Strategy Name
input br broker = up; //Broker Short code ab - aliceblue, tj- tradejini, zb - zebu , en - enrich
input string ver = "1.0"; //API Version


string response;
string api_data;
int Buy;
int Sell;

static int BarsOnChart;

#import "AMMT4BRIDGE.dll"
     string AMDispatcher(string api_key, string api_secret, string api_name, string api_data, string br_code, string version);
#import

//+------------------------------------------------------------------+
//| BuyOrder  function                                               |
//+------------------------------------------------------------------+  


void BuyOrder(int orderquantity)
   {
  
     //Algomojo Place Buy Order


      api_data ="{\"strg_name\":\""+stgy_name+"\",\"symbol\":\""+symbol+"\",\"exchange\":\""+EnumToString(exchange)+"\",\"transaction_type\":\""+"B"+"\",\"duration\":\""+duration+"\",\"order_type\":\""+EnumToString(order_type)+"\",\"quantity\":\""+IntegerToString(quantity)+"\",\"disclosed_quantity\":\""+IntegerToString(disclosed_quantity)+"\",\"MktPro\":\""+"NA"+"\",\"price\":\""+IntegerToString(Price)+"\",\"trigger_price\":\""+IntegerToString(TrigPrice)+"\",\"product\":\""+EnumToString(product)+"\",\"is_amo\":\""+AMO+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Buy Order response : " ,response);
      
      
    }


//+------------------------------------------------------------------+
//| SellOrder  function                                              |
//+------------------------------------------------------------------+    
    
void SellOrder(int orderquantity)
   {
  
      //Algomojo Place Sell Order
      api_data ="{\"strg_name\":\""+stgy_name+"\",\"symbol\":\""+symbol+"\",\"exchange\":\""+EnumToString(exchange)+"\",\"transaction_type\":\""+"S"+"\",\"duration\":\""+duration+"\",\"order_type\":\""+EnumToString(order_type)+"\",\"quantity\":\""+IntegerToString(quantity)+"\",\"disclosed_quantity\":\""+IntegerToString(disclosed_quantity)+"\",\"MktPro\":\""+"NA"+"\",\"price\":\""+IntegerToString(Price)+"\",\"trigger_price\":\""+IntegerToString(TrigPrice)+"\",\"product\":\""+EnumToString(product)+"\",\"is_amo\":\""+AMO+"\"}";
         
      response=AMDispatcher(user_apikey, api_secretkey,"PlaceOrder",api_data,EnumToString(broker),ver);
      Print("api : " ,api_data);
      Print("Algomojo Sell Order response : " ,response);
         
   
   
   }         

int OnInit()
  {
//---
  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---   
   Buy = Close[1] > EMA(10,1)  && Close[2] < EMA(10,2);
   Sell = Close[1] < EMA(10,1) && Close[2] > EMA(10,2);
   
   if(Buy && BarsOnChart != Bars) {      
       BuyOrder(quantity);
       Print("Buy Signal");
       BarsOnChart = Bars;
       PlaySound("Ok.wav");
   }
  
   
   if(Sell && BarsOnChart != Bars) {
      SellOrder(quantity);
      Print("Sell Signal");
      BarsOnChart = Bars;
      PlaySound("Ok.wav");
   }   
  
  }
//+------------------------------------------------------------------+

double EMA(int period,int shift) {
   return iMA(Symbol(), 0, period, 0, MODE_EMA, PRICE_CLOSE, shift);
  
}




